<?php namespace UpsEuWoocommerce\libsystems\lang;

/**
 * _USER_TECHNICAL_AGREEMENT
 * 
 * @category  ups-shipping-for-woocommerce
 * @package   UPS Shipping and UPS Access Point™ : Official Plugin For WooCommerce
 * @author    United Parcel Service of America, Inc. <noreply@ups.com>
 * @license   This work is Licensed under the Apache License, version 2.0
 * https://www.apache.org/licenses/LICENSE-2.0
 * @copyright (c) 2019, United Parcel Service of America, Inc., all rights reserved
 * @link      https://www.ups.com/pl/en/services/technology-integration/ecommerce-plugins.page
 * 
 * _LICENSE_TAG
 *
 * ups-eu-woo-lang-about-logs-api.php - The core plugin class.
 * 
 * This is used to load About's languages.
 */

include_once(dirname(__FILE__, 3) . '/ups-eu-woo-autoloader.php');
new \UpsEuWoocommerce\Ups_Eu_Woo_Main_Autoloader('Ups_Eu_Woo_About_Logs_Api_Language');

class Ups_Eu_Woo_About_Logs_Api_Language extends Ups_Eu_Woo_Common_Language
{

    protected $list_lang;

    /*
     * Name function: __construct
     * Params:
     *  @domain: type string
     * Return: type void
     * * */

    public function __construct($domain)
    {
        parent::__construct($domain);
    }
    /*
     * Name function: ups_eu_woo_load_lang
     * Params: empty
     * Return: type array
     * * */

    public function ups_eu_woo_load_lang()
    {
        /* Get load lang common */
        $lang_common = parent::ups_eu_woo_load_lang();
        /* Additions lang */
        $model_logs_api = new \UpsEuWoocommerce\models\Ups_Eu_Woo_Model_Logs_Api();

        $page_lang = [
            $model_logs_api->col_id => __("ID", $this->domain),
            $model_logs_api->col_method => __("method", $this->domain),
            $model_logs_api->col_full_uri => __("Full url", $this->domain),
            $model_logs_api->col_response => __("Response", $this->domain),
            $model_logs_api->col_request => __("Request", $this->domain),
            $model_logs_api->col_response => __("Response", $this->domain),
            $model_logs_api->col_time_request => __("Time Request", $this->domain),
            $model_logs_api->col_time_response => __("Time Response", $this->domain),
            "title_about_logs_api" => __("About", $this->domain),
            "version_title" => __("Module version number and release date", $this->domain),
            "plugin_version" => __("Module version v1.0.6", $this->domain),
            "minor_bug_fixes" => __("Minor bug fixes", $this->domain),
            "plugin_release_date" => __("Release date August 22, 2019", $this->domain),
            "for_more_infomation_1" => __("For more information visit %s", $this->domain),
            "compatible" => __("Compatible with WooCommerce versions 3.2, 3.3", $this->domain),
            "Support_information" => __("Support information", $this->domain),
            "Support_information_1" => __("For assistance with installing, upgrading, or using UPS Shipping Module, please contact UPS at -", $this->domain),
            "Support_information_2" => __("Poland +48 (0) 22 203 03 21", $this->domain),
            "changelog" => __("Changelog", $this->domain),
            "platfrom_capatibility" => __("Platform compatibility statement", $this->domain),
            "back_link" => __("UPS Shipping Module website", $this->domain),
        ];
        return array_merge($lang_common, $page_lang);
    }
}
