<?php namespace UpsEuWoocommerce\libsystems\lang;

/**
 * _USER_TECHNICAL_AGREEMENT
 * 
 * @category  ups-shipping-for-woocommerce
 * @package   UPS Shipping and UPS Access Point™ : Official Plugin For WooCommerce
 * @author    United Parcel Service of America, Inc. <noreply@ups.com>
 * @license   This work is Licensed under the Apache License, version 2.0
 * https://www.apache.org/licenses/LICENSE-2.0
 * @copyright (c) 2019, United Parcel Service of America, Inc., all rights reserved
 * @link      https://www.ups.com/pl/en/services/technology-integration/ecommerce-plugins.page
 * 
 * _LICENSE_TAG
 *
 * ups-eu-woo-lang-package-dimension.php - The core plugin class.
 * 
 * This is used to load the Package Dimension's languages.
 */

include_once(dirname(__FILE__, 3) . '/ups-eu-woo-autoloader.php');
new \UpsEuWoocommerce\Ups_Eu_Woo_Main_Autoloader('Ups_Eu_Woo_Package_Dimension_Language');

class Ups_Eu_Woo_Package_Dimension_Language extends Ups_Eu_Woo_Common_Language
{

    protected $list_lang;

    /*
     * Name function: __construct
     * Params:
     *  @domain: type string
     * Return: type void
     * * */

    public function __construct($domain)
    {
        parent::__construct($domain);
    }
    /*
     * Name function: ups_eu_woo_load_lang
     * Params: empty
     * Return: type array
     * * */

    public function ups_eu_woo_load_lang()
    {
        /* Get load lang common */
        $lang_common = parent::ups_eu_woo_load_lang();
        /* Addition lang */
        $page_lang = [
            "DefaultPackage" => __("Default package", $this->domain),
            "DefaultPackageSetting" => __("Default package setting", $this->domain),
            "pls_enter_package" => __("Please enter weight and dimensions of your packaging here. You can add multiple package dimensions, which can be easily selected in a dropdown option when creating shipments in the plug-in.<br><br>In case you decide to show the real time UPS shipping rate (to be configured in the next screen) to the e-shoppers, the plug-in will use the first package, referred to as the \"Default Package\" that is displayed below. The Default Package's weight and dimensions will be used to calculate the UPS shipping rates that will be displayed to the e-shoppers.", $this->domain),
            "AddNewPackage" => __("Add New Package", $this->domain),
            "AddPackage" => __("Add Package", $this->domain),
            "RemovePackage" => __("Remove Package", $this->domain),
            "confirm_remove" => __("You are going to remove this default package from your profile.<br>Click Ok to confirm, close the dialog to cancel.", $this->domain),
            "InputMissing" => __("Input missing", $this->domain),
            "pls_input_at_least_one" => __("Please input at least one default package to continue", $this->domain),
            "PackageName" => __("Package name", $this->domain),
            "warningWeightPackageMaximum" => __("Warning! Maximum allowable per package weight for shipments created for UPS Access Points is 20.00 kgs or 44.09 lbs.", $this->domain),
            "errorWeightPackageMaximum" => __("Error! Maximum allowable per package weight is 70.00 kgs or 154.32 lbs.", $this->domain),
            "errorDimension" => __("Error! Package exceeds the maximum allowable size of 400 cm or 157.48 inches (the maximum allowable size calculation = length + 2 * width + 2 * height).", $this->domain),
            "warningDimension" => __("Warning! Maximum allowable per package size for shipments created for UPS Access Points is 330 cm or 129.92 inches (the maximum allowable size calculation = length + 2 * width + 2 * height).", $this->domain),
            "Un-Archiving Orders" => __("Un-Archiving Orders", $this->domain),
            "placeholder_example" => __("Example: Standard, Large, Phone box, etc.", $this->domain),
            "EditDefaultPackage" => __("Editing Default Package", $this->domain),
        ];
        return array_merge($lang_common, $page_lang);
    }
}
