<?php namespace UpsEuWoocommerce\utils;

/**
 * _USER_TECHNICAL_AGREEMENT
 * 
 * @category  ups-shipping-for-woocommerce
 * @package   UPS Shipping and UPS Access Point™ : Official Plugin For WooCommerce
 * @author    United Parcel Service of America, Inc. <noreply@ups.com>
 * @license   This work is Licensed under the Apache License, version 2.0
 * https://www.apache.org/licenses/LICENSE-2.0
 * @copyright (c) 2019, United Parcel Service of America, Inc., all rights reserved
 * @link      https://www.ups.com/pl/en/services/technology-integration/ecommerce-plugins.page
 * 
 * _LICENSE_TAG
 *
 * ups-eu-woo-utils-activator.php - The core plugin class.
 * 
 * This is used to active the current plugin.
 */

require_once(dirname(__FILE__, 2) . '/ups-eu-woo-autoloader.php');
new \UpsEuWoocommerce\Ups_Eu_Woo_Main_Autoloader('Ups_Eu_Woo_Utils_Activator');

class Ups_Eu_Woo_Utils_Activator
{
    public static function ups_eu_woo_activate()
    {
        $ResourceSystems = new Ups_Eu_Woo_Utils_Resource_Systems();
        $ResourceSystems->ups_eu_woo_sys_activate();
        self::ups_eu_woo_verify_merchant();
        call_user_func_array([
            new \UpsEuWoocommerce\libsystems\api_ups\Ups_Eu_Woo_Manage_Api_Ups()
            , "ups_eu_woo_upgrade_plugin_version"
        ], []);
    }

    private function ups_eu_woo_verify_merchant() {
        $model_config = new \UpsEuWoocommerce\models\Ups_Eu_Woo_Model_Config();
        if ($model_config->ups_eu_woo_get_by_key($model_config->ups_shipping_merchant_key) !== true) {
            $model_config->key = $model_config->ups_shipping_merchant_key;
            $model_config->value = $model_config->ups_eu_woo_created_key_merchant();
            $model_config->scope = "default";
            $model_config->ups_eu_woo_save();
        }
    }
}
